/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (II)        *
 *            - OtBbNEƎ\[XE{EʐM -             *
 *                                                                     *
 *      Copyright 1995,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static void SelectCB();
static void PasteCB();
static Boolean ConvertProc();
static void LoseProc();
static void DoneProc();
static void GetValueProc();

static Atom xa_ctext;

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, text, select, paste;
    Arg al[20];
    int ac;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Selection", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* eLXg͗̈ */
    ac = 0;
    text = XmCreateText(panel, "text", al, ac);
    XtManageChild(text);

    /* [eLXgI] {^ --> L: ZNVL */
    ac = 0;
    select = XmCreatePushButton(panel, "select", al, ac);
    XtAddCallback(select, XmNactivateCallback, SelectCB, text);
    XtManageChild(select);

    /* [y[Xg] {^ --> v: ZNVEf[^v */
    ac = 0;
    paste = XmCreatePushButton(panel, "paste", al, ac);
    XtAddCallback(paste, XmNactivateCallback, PasteCB, text);
    XtManageChild(paste);

    /* RpEhEeLXg̃Ag𐶐Ă */
    xa_ctext = XmInternAtom(XtDisplay(toplevel), "COMPOUND_TEXT", False);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

/* L: [eLXgI] {^̃R[obN */
static void SelectCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;

    /* ZNVL (3̃R[obNo^) */
    if (XtOwnSelection(text, XA_PRIMARY,
                       XtLastTimestampProcessed(XtDisplay(text)),
                       ConvertProc, LoseProc, DoneProc))
        /* LłCeLXg\Ēm点 */
        XmTextSetHighlight(text, 0, XmTextGetLastPosition(text),
                           XmHIGHLIGHT_SELECTED);
}

/* L: ZNV̏LƂɌĂяo */
static void LoseProc(w, selection)
    Widget w;
    Atom *selection;
{
    /* ZNV̏L҂łȂȂC\ */
    if (*selection == XA_PRIMARY)
        XmTextSetHighlight(w, 0, XmTextGetLastPosition(w), XmHIGHLIGHT_NORMAL);
}

/* v: [y[Xg] {^̃R[obN */
static void PasteCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;

    /* (1) RpEhEeLXg`ŃZNṼf[^v */
    XtGetSelectionValue(text, XA_PRIMARY, xa_ctext, GetValueProc, NULL,
                        XtLastTimestampProcessed(XtDisplay(text)));
}

/* L: ZNṼf[^vꂽƂɌĂяo */
static Boolean ConvertProc(w, selection, target,
                           type_ret, val_ret, len_ret, format_ret)
    Widget w;
    Atom *selection;
    Atom *target;
    Atom *type_ret;
    XtPointer *val_ret;
    unsigned long *len_ret;
    int *format_ret;
{
    char *string;
    XTextProperty textprop;

    /* ]f[^pӂĕԂ */
    if (*selection == XA_PRIMARY && *target == xa_ctext) {
        string = XmTextGetString(w);  /* ]͓̂͂ꂽeLXg */
        /* (2) }`oCgRpEhEeLXgɕϊ */
        if (XmbTextListToTextProperty(XtDisplay(w), &string, 1,
                                      XStdICCTextStyle, &textprop) != Success)
            return False;  /* ϊɎs (͂ꂽ) */
        XtFree(string);
        *val_ret = textprop.value;    /* RpEhEeLXg] */
        *len_ret = strlen(textprop.value);
        *type_ret = xa_ctext;         /* {Ȃ̂ŃRpEhEeLXg */
        *format_ret = 8;              /* ̃tH[}bg 8 */
        return True;   /* ]f[^̏ɐƂ} */
    }
    else
        return False;  /* vꂽZNVƃ^CvႤ */
}

/* v: ZNṼf[^󂯎ƂɌĂяo */
static void GetValueProc(w, client_data, selection, type, val, len, format)
    Widget w;
    XtPointer client_data;
    Atom *selection;
    Atom *type;
    XtPointer val;
    unsigned long *len;
    int *format;
{
    XTextProperty textprop;
    char **clist;
    int count;

    if (*len == 0 || val == NULL) { /* f[^̎󂯎Ɏs */
        XBell(XtDisplay(w), 0);  /* xŎs̍} */
        return;
    }

    if (*selection == XA_PRIMARY && *type == xa_ctext) {
        /* (3) RpEhEeLXg}`oCgɖ߂ */
        textprop.value = val;
        textprop.encoding = *type;
        textprop.format = *format;
        textprop.nitems = *len;
        if (XmbTextPropertyToTextList(XtDisplay(w),
                                      &textprop, &clist, &count) != Success)
            XBell(XtDisplay(w), 0);  /* ϊɎsƃxō} */

        /* 󂯎f[^eLXgEEBWFbgɃy[Xg */
        XmTextSetString(w, clist[0]);
        XFreeStringList(clist);  /* svȂ̂ŉ */
	XtFree((char *)val);
    }
    else
        XBell(XtDisplay(w), 0);  /* ^CvႤƃxŎs̍} */
}

/* L: v҂f[^󂯎ŌĂяo */
static void DoneProc(w, selection, target)
    Widget w;
    Atom *selection;
    Atom *target;
{
    /* ]ɕKvȂƂ΁CŎs */
    /* ̃R[obNo^Ƃ̓AvP[Vf[^邱 */
    /* o^Ȃꍇ́CXt IɃf[^ */
}
